use rinja::Template;

use crate::{
    filters,
    models::{Availability, AvailabilityTime, AvailabillityAssignmentState, Event},
};

pub mod delete;
pub mod post_new;

#[derive(Template)]
#[template(path = "events/plan_personal_table.html")]
pub struct PlanEventPersonalTablePartialTemplate {
    event: Event,
    availabillities: Vec<(Availability, AvailabillityAssignmentState)>,
    further_posten_required: bool,
    further_fuehrungsassistent_required: bool,
    further_wachhabender_required: bool,
}
